// pages/replyQuestions/replyQuestions.js
var app = getApp()
var miucms = require('../../utils/miucms.js');
var WxParse = require('../../wxParse/wxParse.js');
var config = {};
var loading = false,
  loading_new = false;
var have_new_msg = true;
var windowHeight = 0,
  windowWidth = 0;
var tempFilePaths = [],
  tempFilePath = '';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    questions: [],
    can_submit: false,
    status: '',
    avatar: '',
    show_custom: false,
    show_fast_reply: false,
    uniqid: 'jayaiqDyHvv5',
    token: '',
    messageid: '',
    XiaoappHKid: '',
    islandlord: false,
    lastmessageid: 0,
    maxmessageid: 0,
    page: {
      next_page: 1
    },
    pagemessageid: 0,
    count: 0,
    data: [],
    impression: [],
    reply_message: '',
    show_new_msg: false,
    customreply: [],
    q: "",
    show_page: false,
    can_get_new: false,
    can_send: false,
    function_show: false,
    video_obj: {
      show: false,
      src: ''
    },
    scrollHeight: '', //聊天记录窗口高度
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    this.setData({
      uniqid: options.uniqid,
      q: options.q ? options.q : ''
    })
    this.get_config()
  },
  get_config() {
    var that = this;
    if (app.globalData.config.lists) {
      config = app.globalData.config;
      wx.showLoading({
        title: '加载中',
      })
      that.setData({
        user: app.globalData.user,
        status: app.globalData.status
      })

      this.to_message_show();
    } else {
      setTimeout(function() {
        that.get_config()
      }, 200)
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {
    console.log('onShow')
    var that = this;
    wx.getSystemInfo({
      success: function(res) {
        windowHeight = res.windowHeight;
        windowWidth = res.windowWidth;
      },
    })
    if (this.data.show_fast_reply) {
      wx.getStorage({
        key: 'message',
        success: function(res) {
          console.log(res)
          that.setData({
            customreply: res.data,
            show_fast_reply: false
          })
          wx.removeStorage({
            key: 'message',
            success: function(res) {},
          })
        },
      })
    }
    this.setData({
      show_page: true
    })
    this.data.can_get_new && this.get_new_msg()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {
    console.log('onHide')
    this.setData({
      show_page: false
    })
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {
    console.log('onUnload')

    this.setData({
      show_page: false
    })
    if (this.data.video_obj.show === true) {
      this.close_video()
      return false
    }
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },

  /**
   * 用户点击右上角分享
   */
  // onShareAppMessage: function () {

  // },

  input: function(e) {
    let that = this;

    if (e.detail.value.trim() !== '') {
      this.setData({
        reply_message: e.detail.value,
        can_send: true
      })
    } else {
      this.setData({
        reply_message: e.detail.value,
        can_send: false
      })
    }
  },

  to_fast_reply: function(e) {
    let that = this;
    let data = that.data.customreply;
    wx.setStorage({
      key: 'message',
      data: data,
      success: function(res) {
        that.setData({
          show_fast_reply: true,
          show_custom: false
        })
        wx.navigateTo({
          url: '../setFastrReply/setFastrReply',
        })
      }
    })
  },
  // 在线聊天页
  to_message_show: function() {
    var that = this;
    // 避免重複加載
    if (loading || that.data.pagemessageid === false) {
      return false
    }
    loading = true;
    wx.showLoading({
      title: '加载中',
    })
    miucms.request(app.globalData.config.message.show, {
      uniqid: that.data.uniqid,
      pagemessageid: that.data.pagemessageid,
    }).then(data => {



      if (data.extraparam && data.extraparam.mode == 'alert') {
        wx.showModal({
          title: '',
          content: data.message,
        })
      } else {
        // for (let i = 0; i < data.data.length; i++) {
        //   if (data.data[i].event != 'Answer' && data.data[i].type == 'text') {              
        //     data.data[i].message = data.data[i].message.split('\n')
        //   } else if (data.data[i].event == 'Answer'){
        //     console.log('Answer', data.data[i])
        //     for (let j = 0; j < data.data[i].message.length;j++){
        //       console.log(data.data[i].message[j])
        //       data.data[i].message[j].message = data.data[i].message[j].message.split('\n')
        //     }
        //   }
        // }  
        that.data.data = data.data.concat(that.data.data);
        if (that.data.pagemessageid == 0) {
          that.setData({
            lastmessageid: data.lastmessageid,
            impression: data.impression,
            can_get_new: true
          })
          setTimeout(function() {
            that.get_new_msg()
          }, 2000)
        }
        that.setData({
          islandlord: data.islandlord,
          maxmessageid: data.maxmessageid,
          // page:data.page,
          pagemessageid: data.pagemessageid,
          count: data.count,
          data: that.data.data,
          customreply: data.customreply
        })
      }
    }).catch(res=>{})
  },
  to_show_custom: function(e) {
    var show = e.currentTarget.dataset.show == 'true' ? true : false;

    this.setData({
      show_custom: show
    })
  },
  reply: function(e) {
    var that = this;
    if (that.data.reply_message.trim().length == 0) {
      wx.showModal({
        title: '提示',
        content: '不能发送空白消息',
      })

    } else {
      //  type  '消息类型 (voice:语音,text:文本, image:图片,video:视频,map:地图)
      miucms.request(app.globalData.config.message.send, {
        uniqid: that.data.uniqid,
        message: that.data.reply_message,
        formid: e.detail.formId,
        type: 'text',
      }).then(data => {
        if (data.extraparam && data.extraparam.mode == 'right') {
          that.setData({
            reply_message: '',
            can_send: false
          })
        }
      }).catch(res=>{})
    }
  },
  upper: function() {
    this.to_message_show()
  },
  // 滚动到屏幕底部时，如果有新消息，则跳到新消息去，没有就不跳
  lower: function() {

  },
  scroll: function(e) {
    var that = this;
    if (e.detail.scrollHeight - e.detail.scrollTop > windowHeight * 1.5) {
      have_new_msg = false;
    } else {
      have_new_msg = true;
      that.setData({
        show_new_msg: false
      })
    }
  },
  // 获取最新消息
  get_new_msg: function() {
    var that = this;
    // console.log(this.data.show_page)
    if (this.data.show_page === true) {
      setTimeout(function() {
        that.get_new_msg()
      }, 1000)
    }
    if (loading_new) {
      return false
    }
    loading_new = true;

    miucms.request(app.globalData.config.message.monitoring, {
      uniqid: that.data.uniqid,
      lastmessageid: that.data.lastmessageid
    }).then(data => {
      if (data.extraparam && data.extraparam.mode == 'alert') {
        wx.showModal({
          title: '',
          content: data.message,
        })
      } else {

        // for(let i=0;i<data.data.length;i++){
        //   if (data.data[i].event != 'Answer'  && data.data[i].type=='text'){
        //     data.data[i].message = data.data[i].message.split('\n')              
        //   }
        // }       

        // 如果在頁面底部，直接跳到最新消息，如果不是，显示有最新消息按钮
        if (data.lastmessageid) {
          that.setData({
            lastmessageid: data.lastmessageid
          })
        }
        if (data.data.length > 0) {
          that.data.data = that.data.data.concat(data.data);
          that.setData({
            data: that.data.data
          })
          if (have_new_msg) {
            that.setData({
              maxmessageid: data.lastmessageid,
              show_new_msg: false
            })
          } else {
            that.setData({
              show_new_msg: true
            })
          }
        }
      }
    }).catch(res=>{})
  },
  to_new_msg: function() {
    var that = this;
    that.setData({
      maxmessageid: that.data.lastmessageid,
      show_new_msg: false
    })
  },
  select_item: function(e) {
    var content = e.currentTarget.dataset.content;
    this.setData({
      reply_message: content,
      show_custom: false,
      can_send: true
    })
    // this.reply()
  },
  get_img: function() {
    var that = this;

    wx.chooseImage({
      count: 9,
      success: function(res) {
        tempFilePaths = res.tempFilePaths;
        that.upload_pic(0, res.tempFilePaths.length)

      }
    })
  },
  upload_pic: function(index, length) {
    var that = this;
    const uploadTask = wx.uploadFile({
      url: 'https://app.gter.net/upload',
      filePath: tempFilePaths[index],
      name: 'files',
      formData: {
        uniqid: that.data.uniqid,
        session: app.globalData.session
      },
      header: app.globalData.header,
      success: function(res) {
        var data = app.return_data(res);


        // 上传成功

        // 发送消息
        wx.request({
          url: app.globalData.config.message.send,
          data: {
            session: wx.getStorageSync('session'),
            uniqid: that.data.uniqid,
            message: data.aid,
            type: 'image',
            aid: data.aid
          },
          method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
          header: app.globalData.header,
          success: function(res) {
            var data = app.return_data(res);
            if (data.extraparam && data.extraparam.mode == 'right') {}
          }
        })
        index++;
        if (index < length) {
          that.upload_pic(index, length)
        }
      },
      fail: function(res) {
        wx.showModal({
          content: res,
        })
      }
    })
    uploadTask.onProgressUpdate((res) => {
      console.log('上传进度', res.progress)
    })
  },
  get_video: function() {
    let that = this;
    wx.chooseVideo({
      count: 9,
      success: function(res) {
        tempFilePath = res.tempFilePath;
        that.upload_video(0, 1)
      }
    })
  },
  upload_video: function(index, length) {
    var that = this;

    const uploadTask = wx.uploadFile({
      url: 'https://app.gter.net/upload',
      filePath: tempFilePath,
      name: 'files',
      formData: {
        uniqid: that.data.uniqid,
        session: app.globalData.session,
        type: 'video'
      },
      header: app.globalData.header,
      success: function(res) {
        var data = app.return_data(res);
        // 发送消息
        wx.request({
          url: app.globalData.config.message.send,
          data: {
            session: wx.getStorageSync('session'),
            uniqid: that.data.uniqid,
            message: data.aid,
            type: 'video',
            aid: data.aid
          },
          method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
          header: app.globalData.header,
          success: function(res) {
            var data = app.return_data(res);
            if (data.extraparam && data.extraparam.mode == 'right') {}
          }
        })

      },
      fail: function(res) {
        console.log(res)
      }
    })
    // uploadTask.onProgressUpdate((res) => {
    //   for (let i = 0; i < that.data.imgs.length; i++) {
    //     if (that.data.imgs[i].id === id_now) {
    //       that.data.imgs[i]['progress'] = res.progress == 100 ? 0 : res.progress;
    //       that.setData({
    //         videos: that.data.videos
    //       })
    //     }
    //   }
    // })
  },
  get_location: function() {
    let that = this;
    wx.chooseLocation({
      success: function(res) {
        // 发送消息
        miucms.request(app.globalData.config.message.send, {
          uniqid: that.data.uniqid,
          type: 'map',
          message: res,
        }).then(data => {

        }).catch(res => {})
      },
    })
  },
  // 去地图
  to_map: function(e) {
    console.log(e)
    var that = this;
    var latitude = Number(e.currentTarget.dataset.latitude);
    var longitude = Number(e.currentTarget.dataset.longitude);
    var address = e.currentTarget.dataset.address;
    wx.openLocation({
      latitude: latitude,
      longitude: longitude,
      scale: 28,
      // name: name,
      address: address
    })
  },
  imageLoad: function(e) {
    let originalWidth = e.detail.width;
    let originalHeight = e.detail.height;
    let index = e.currentTarget.dataset.index;
    this.data.data[index].image_height = originalHeight * (windowWidth - 74) / originalWidth
    this.setData({
      data: this.data.data
    })
  },
  // 图片预览
  previewimg: function(e) {
    let arr = [];
    var data = this.data.data;
    for (let i = 0; i < data.length; i++) {
      if (data[i].type == 'image') {
        arr.push(data[i].message)
      }
    }
    let index = e.currentTarget.dataset.index;
    wx.previewImage({
      current: data[index].message, // 当前显示图片的http链接
      urls: arr // 需要预览的图片http链接列表
    })
  },
  // 设置印象
  check_item: function(e) {
    var that = this;
    var impression = '' + e.currentTarget.dataset.impression;
    var index = e.currentTarget.dataset.index;
    wx.showLoading({
      title: '数据提交中',
    })
    miucms.request(app.globalData.config.message.setimpression,{
      uniqid: that.data.uniqid,
      impression: impression
    }).then(data=>{
      if (data.extraparam.mode == 'right') {
        for (var i = 0; i < that.data.impression.length; i++) {
          that.data.impression[i].selected = false;
        }
        that.data.impression[index].selected = true;
        that.setData({
          impression: that.data.impression
        })
      }
    }).catch(res=>{})
   
  },
  to_show_functions: function(e) {
    let that = this;
    if (this.data.function_show === true) {
      this.onfocus()
      return false
    }
    this.setData({
      function_show: true,
      maxmessageid: that.data.data[that.data.data.length - 1].id
    })
    setTimeout(function() {
      wx.pageScrollTo({
        scrollTop: 5000,
      })
    }, 50)
    // this.get_img()
  },
  onfocus: function() {
    this.setData({
      function_show: false
    })
    setTimeout(function() {
      wx.pageScrollTo({
        scrollTop: 0,
      })
    }, 50)
  },

  wxParseTagATap: function(e) {
    var url = e.currentTarget.dataset.src;
    // console.log(e)
    wx.navigateTo({
      url: url,
    })
  },
  show_video: function(e) {
    var src = e.currentTarget.dataset.src;
    // this.setData({
    //   video_obj:{
    //     show:true,
    //     src: src
    //   }
    // })
    wx.navigateTo({
      url: '../video_show/video_show?src=' + src
    })
  },

})