// pages/quarantineLists/quarantineLists.js
var app = getApp()
var config = {};
var miucms = require('../../utils/miucms.js');
var WxParse = require('../../wxParse/wxParse.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isloding: true,
    StudentapartmentNew: null,//是否顯示new
    showTOTOP: false,
    tid: '',
    uniqid: '0W4XS5SrvSHD',
    token: '',

    imgUrls: [],

    page: {
      next_page: 1
    },
    data: [],
    contact: {},
    loading: false,
    info: {
      subject: '寄托香港租房-14天房源'
    },
    listTab: {}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.get_config()
  },
  onPageScroll(e) {
    if (e.scrollTop > 1000 && !this.data.showTOTOP) {
      this.setData({
        showTOTOP: true
      })
    } else if (e.scrollTop < 1000 && this.data.showTOTOP) {
      this.setData({
        showTOTOP: false
      })
    }
  },
  /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
  onPullDownRefresh: function () {
    this.setData({
      page: {
        next_page: 1
      },
      data: []
    })
    this.getList()
    wx.stopPullDownRefresh();
  },
  onReachBottom() {
    // 加载下一页

    this.getList()
  },


  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {

    if (res.from === 'button') {
      // 来自页面内转发按钮
      var types = res.from === 'button' ? 'share_btn' : 'show';
    }
    let that = this;
    return {
      title: '寄托香港租房-' + this.data.listTab.quarantineLists,
      imageUrl: that.data.info.share_img,
      success: function (res) {
        miucms.share(app, types)
      },
      fail: function (res) {
        // 转发失败
      }
    }

  },
  get_config() {
    var that = this;
    if (app.globalData.config && app.globalData.config.lists) {

      config = app.globalData.config;

      that.data.user = app.globalData.user;
      this.setData({
        screen_data: app.globalData.screen_data,
        StudentapartmentNew: app.globalData.StudentapartmentNew,
        listTab: app.globalData.listTab
      })
      this.get_content();
      this.getList();
     

    } else {
      setTimeout(function () {
        that.get_config()
      }, 200)
    }
  },
  getList: function () {
    let that = this;
    if (this.data.page.next_page === 0) {
      return false
    }
    if (this.data.loading) {
      return false
    }
    this.setData({
      loading: true
    })

    miucms.request(app.globalData.config.studentapartment.quarantineLists, { page: this.data.page.next_page }).then(data => {
      if (data.extraparam) {
        wx.showModal({
          title: '提示',
          content: data.message,
        })
      } else {
        that.setData({
          data: that.data.data.concat(data.data),
          page: data.page,
          contact: data.contact,
          loading: false,
          isloding: false
        })
      }
      wx.hideLoading()

    }).catch(res => { })


  },
 
  get_content: function () {
    let that = this;
    var sendData = Object.assign({}, this.data.options, {
      session: wx.getStorageSync('session'),

    })
    miucms.request(app.globalData.config.studentapartment.quarantineBanner, {}).then(data => {
      wx.hideLoading()
      if (data.extraparam) {
        wx.showModal({
          title: '提示',
          content: data.message,
        })
      } else {

        that.setData({
          imgUrls: data.data
        })

      }
    }).catch(res => { })

  },
  copy(e) {
    loading
    const content = e.currentTarget.dataset.content;
    miucms.copy(content).then((res) => {
      console.log('res', res)
    }).catch(err => {
      console.log(err)
    })

  },
})