// template/choiceTypeRelease/choiceTypeRelease.js
Component({
    /**
     * 组件的属性列表
     */
    properties: {

    },

    /**
     * 组件的初始数据
     */
    data: {
        list: [{
            name: "我是房东",
            explain: "出租自有物业",
        }, {
            name: "我是中介",
            explain: "持有房产代理牌照",
        }, {
            name: "有房招室友",
            explain: "我已租房，需要招室友",
        }, {
            name: "其他",
            explain: "二房东、物业租赁公司等",
        }, ],
        rulesList: [{
                content: `中介账号发布的房源信息，均展示在“<span style="color: #000; font-weight:650;">中介房源</span>”频道中，即不能发布“<span style="color: #000; font-weight:650;">个人房源</span>”、“<span style="color: #000; font-weight:650;">求房源</span>”；如您已上架个人房源或求房源信息，在你确认中介身份后，将会自动下架`,
                type: 1,
            }, {
                content: `个人账号只能发布“<span style="color: #000; font-weight:650;">个人房源</span>”、“<span style="color: #000; font-weight:650;">求房源</span>”，在您确认不是中介身份后，将会自动下架您的中介房源；`,
                type: 1,
            }, {
                content: `中介账号只能发布“<span style="color: #000; font-weight:650;">中介房源</span>”，如您已上架个人房源或求房源信息，在你确认中介身份后，将会自动下架；`,
                type: 1,
            }, {
                content: `中介账号（未认证）最多可同时上架 <span style="color: #000; font-weight:650;">3</span> 条房源信息`,
                type: 1,
            }, {
                content: `中介账号（有认证）最多可同时上架 <span style="color: #000; font-weight:650;">20</span> 条房源信息`,
                type: 1,
            }, {
                content: `中介帐号（有认证）拥有搜索、过滤“<span style="color: #000; font-weight:650;">求房源</span>”信息的功能`,
                type: 1,
            },


        ]
        // rulesList: [{
        //         content: `中介账号发布的房源信息，均展示在“<span style="color: #000; font-weight:650;">中介房源</span>”频道中，即不能发布“<span style="color: #000; font-weight:650;">个人房源</span>”、“<span style="color: #000; font-weight:650;">求房源</span>”；如您已上架个人房源或求房源信息，在你确认中介身份后，将会自动下架`,
        //         type: 1,
        //     },
        //     {
        //         content: `个人账号只能发布“<span style="color: #000; font-weight:650;">个人房源</span>”、“<span style="color: #000; font-weight:650;">求房源</span>”，在您确认不是中介身份后，将会自动下架您的中介房源；`,
        //         type: 1,
        //     },
        //     {
        //         content: `中介账号只能发布“<span style="color: #000; font-weight:650;">中介房源</span>”，如您已上架个人房源或求房源信息，在你确认中介身份后，将会自动下架；`,
        //         type: 1,
        //     },
        //     {
        //         content: `中介账号（未认证）最多可同时上架 <span style="color: #000; font-weight:650;">3</span> 条房源信息`,
        //         type: 1,
        //     },
        //     {
        //         content: `中介账号（有认证）最多可同时上架 <span style="color: #000; font-weight:650;">20</span> 条房源信息`,
        //         type: 1,
        //     },
        //     {
        //         content: `中介帐号（有认证）拥有搜索、过滤“<span style="color: #000; font-weight:650;">求房源</span>”信息的功能`,
        //         type: 1,
        //     },


        // ]
    },

    /**
     * 组件的方法列表
     */
    methods: {

    }
})